
-- ========================
--  APEX Connect 2024
--  Gunther Pippèrr https://www.pipperr.de/dokuwiki/doku.php
--
-- =========================

set echo ON

--
ALTER SESSION SET  PLSQL_OPTIMIZE_LEVEL=3;

ALTER SESSION SET  PLSQL_CODE_TYPE='NATIVE';
--ALTER SESSION SET  PLSQL_CODE_TYPE='INTERPRETED';


ALTER SESSION SET PLSQL_WARNINGS='ENABLE:ALL';

SET serveroutput ON

create or replace procedure pragmaRun
as
  v_loops  NUMBER := 10000000;
  v_start  NUMBER;
  v_return NUMBER;
  v_cpu_start number;

  FUNCTION add_numbers (p_1 IN NUMBER,
                        p_2 IN NUMBER)
    RETURN NUMBER AS
  BEGIN
    RETURN p_1 + p_2;
  END add_numbers;

BEGIN
  v_start     := DBMS_UTILITY.get_time;
  v_cpu_start := DBMS_UTILITY.GET_CPU_TIME; 

  FOR i IN 1 .. v_loops LOOP
    PRAGMA INLINE (add_numbers, 'YES');
    v_return := add_numbers(1, i);
  END LOOP;

   DBMS_OUTPUT.put_line('Elapsed Time: ' || (DBMS_UTILITY.get_time - v_start) || ' hsecs');
   DBMS_OUTPUT.put_line('Elapsed CPU Time: ' || (DBMS_UTILITY.GET_CPU_TIME - v_cpu_start) || ' hsecs');

END;
/

show error

select NAME, TYPE, SOURCE_SIZE, PARSED_SIZE, CODE_SIZE  from user_object_size where name =  'PRAGMARUN';

begin
 pragmaRun;
end;
/


-- 2 und kein Pragma
-- PRAGMARUN	PROCEDURE	500	1002	976
-- 2 und pragma
-- PRAGMARUN	PROCEDURE	498	1002	663
--3
--PRAGMARUN	PROCEDURE	  500	1002	655

/*
select name                
	, type                
	, plsql_optimize_level
	, plsql_code_type     
	, plsql_debug			
	, plsql_warnings      
	, nls_length_semantics
	, plsql_ccflags       
	, plscope_settings    
 from user_plsql_object_settings 
where name =  'PRAGMARUN';
*/