-- ========================
--  APEX Connect 2024
--  Gunther Pippèrr https://www.pipperr.de/dokuwiki/doku.php
--
-- =========================

set echo ON


ALTER SESSION SET  PLSQL_OPTIMIZE_LEVEL=2;
ALTER SESSION SET PLSQL_WARNINGS='ENABLE:ALL';


--ALTER SESSION SET  PLSQL_CODE_TYPE='NATIVE';
ALTER SESSION SET  PLSQL_CODE_TYPE='INTERPRETED';



create or replace procedure ResultCacheDemo
as
  v_loops  NUMBER := 10000;
  v_start  NUMBER;
  v_return NUMBER;
  v_cpu_start number;

  FUNCTION  add_numbers(p_1 IN NUMBER,
                        p_2 IN NUMBER)
    RETURN NUMBER
    deterministic
    --RESULT_CACHE
    AS
  BEGIN
    RETURN sqrt(p_1 + p_2);
  END add_numbers;

BEGIN
  v_start     := DBMS_UTILITY.get_time;
  v_cpu_start := DBMS_UTILITY.GET_CPU_TIME; 

  FOR i IN 1 .. v_loops LOOP
    PRAGMA INLINE (add_numbers, 'YES');
    v_return := add_numbers(1, i);
  END LOOP;

   DBMS_OUTPUT.put_line('Elapsed Time: ' || (DBMS_UTILITY.get_time - v_start) || ' hsecs');
   DBMS_OUTPUT.put_line('Elapsed CPU Time: ' || (DBMS_UTILITY.GET_CPU_TIME - v_cpu_start) || ' hsecs');

END ResultCacheDemo;
/

---

show error

---

SET serveroutput ON

begin
 ResultCacheDemo;
end;
/

